NAME
    refcheck - berprft die Konsistenz der ALL.REF ($REF) des ST-Guide

SYNOPSIS
    refcheck [-adghiks]

BESCHREIBUNG
    Zuerst liest REFCHECK aus der Datei ST-GUIDE.INF die Variablen PATHS und
    REF. Sollte auerdem die Variable REFPATHS existieren, wird diese 
    anstelle von PATHS benutzt. So kann man bestimmen, da nur die 
    REF-Dateien von Hypertexten aus bestimmten Pfaden in die ALL.REF 
    aufgenommen werden.
    
    Die in der Variablen REF stehende REF-Datei, ist die von REFLINK 
    erzeugte 'REF-Bibliothek' (z.B. ALL.REF). Diese wird geladen und auf 
    ihre Korrektheit und Aktualitt berprft.

    Dazu werden alle HYP-Dateien, die sich in den hinter [REF]PATHS 
    angegebenen Pfaden befinden, gesucht, mit der ALL.REF verglichen und in 
    der ALL.REF berflssige Module (zu denen keine HYP-Datei existiert) 
    angezeigt. Evtl. vorhandene (und zu den HYPs passende) REF-Dateien 
    werden auf Aktualitt und Existenz in der ALL.REF berprft. Auf Wunsch
    wird die ALL.REF durch Aufruf von REFLINK mit der entsprechenden 
    Kommandozeile automatisch aktualisiert.

    Ist die Option -s nicht gesetzt werden alle gefundenen HYP-Dateien und
    Modulnamen zusammen mit Offset und Lnge des Moduls auf dem Bildschirm
    ausgegeben. Erscheint hinter einem Modulnamen ein Ausrufezeichen (!),
    bedeutet das, da der Dateiname nicht mit dem Modulnamen bereinstimmt,
    was aber nur selten vorkommt. Bei solchen Hypertexten sollte man die
    REF-Datei nicht lschen, weil REF-Check sonst beim nchsten Lauf das
    Modul in der ALL.REF nicht zu einem Hypertext zuordnen kann und evtl.
    wieder lschen lt! Die Option -k wird in solchen Fllen automatisch
    deaktiviert (REFLINK wird also fr dieses eine File nicht mit -m,
    sondern mit -a aufgerufen)!

    Um die Bildschirm-Ausgaben von REFCHECK in eine Datei zu schreiben,
    benutzen Sie eine Kommando-Shell mit Ausgabeumlenkung (z.B. Mupfel)!

    Bei Fragen ber den Sinn und Zweck von REF-Dateien, ST-GUIDE.INF,
    REFLINK usw. lesen Sie bitte die Anleitungen zum ST-Guide-System!

OPTIONEN
    -a  (add)
        Neue bzw. aktuellere REF-Dateien in $[REF]PATHS automatisch in $REF
        aufnehmen bzw. aktualisieren.

    -d  (delete)
        Bei in $[REF]PATHS nicht mehr vorhandenen HYP-Dateien automatisch 
        die dazu gehrenden Module aus $REF lschen.

    -g  (global)
        Alle in $[REF]PATHS gefundenen REF-Dateien in $REF aufnehmen bzw.
        aktualisieren, egal ob schon vorhanden und/oder gleiche Modullnge.

    -h  (hold)
        Am Ende auf Tastendruck warten.

    -i  (interactive)
        Bei a/d/g einzeln nachfragen. Dabei wird jeweils die Kommandozeile
        fr REFLINK angezeigt und gefragt, ob REFLINK gestartet werden soll.
        Man kann whlen zwischen:
        J: REFLINK starten (auch Return, deshalb ein groes "J").
        n: REFLINK nicht starten.
        a: Wie "J" und alle weiteren REFLINK-Aufrufe ohne Nachfrage.
           Alle weiteren REFLINK-Aufrufe mit der Option -d (lschen) werden
           anschlieend in einem einzigen Aufruf zusammengefat!
        q: Wie "n" und keine weiteren REFLINK-Aufrufe mehr.

    -k (kill)
       Bei a/g wird REFLINK mit der Option -m (move) gestartet, so da die
       bearbeiteten REF-Dateien anschlieend automatisch gelscht werden.

    -s (silent)
       Die Bildschirmausgaben werden auf das ntigste beschrnkt, wodurch
       eine hhere Geschwindigkeit erzielt wird.

    ([REF]PATHS und REF aus ST-GUIDE.INF!)

    Bei unbekannten Optionen (z.B. -?) wird eine Hilfe ausgegeben!

    Alle Optionen knnen auch ber die Variable REFCHECK-OPT in der Datei
    ST-GUIDE.INF gesetzt werden. Diese Variable wird aber nur ausgewertet,
    wenn die Kommandozeile von REFCHECK leer ist!

    Beispiel: REFCHECK-OPT=ads

    Wer REFCHECK oft oder nur vom Desktop startet und nur noch die Variable
    REFCHECK-OPT nutzt, kann REFCHECK.TTP natrlich in REFCHECK.TOS
    umbenennen, dann entfllt die berflssige TTP-Parameterabfrage!

BEISPIELE
    refcheck
        Die Ergebnisse werden nur am Bildschirm angezeigt (evtl. -h setzen).
        Es finden keine Schreibzugriffe statt. Hiermit kann man sich also
        erstmal einen berblick verschaffen.

    refcheck -ad
        Die ALL.REF wird automatisch und ohne Nachfragen auf den neuesten
        Stand gebracht.

    refcheck -dg
        refcheck erkennt genderte Module mit der Option -a nur daran, da
        sich die Modullnge gendert hat. Will man ganz sicher gehen, kann
        man mit der Option -g ALLE REF-Dateien nochmal neu in die ALL.REF
        schreiben lassen. Anschlieend enthlt diese auf jeden Fall alle
        aktuellen REF-Dateien! Wenn man viele Hypertexte mit REF-Dateien
        hat, kann das natrlich etwas lnger dauern!

DATEIEN
    ST-GUIDE.INF
        Mu sich im HOME-Directory oder im Wurzelverzeichnis des
        Bootlaufwerkes befinden.

    REFLINK.TTP
        Wird evtl. von REFCHECK gestartet. Dazu mu in der Datei 
        ST-GUIDE.INF zwingend die Variable REFLINK (Pfad und Name von 
        REFLINK) definiert sein! Anderenfalls werden die Optionen -[adg] 
        ignoriert und beim Programmstart erscheint eine Warnung!

        Beispiel: REFLINK=h:\hyp\bin\reflink.ttp

ENVIRONMENT
    HOME
        Wird bei der Suche nach der ST-GUIDE.INF ausgewertet.

VERSIONEN
    1.0 - Erstverffentlichung.
    1.1 - Compiliert mit hcc 2.00x23 und gelinkt mit den neuen XDLibs aus
          dem Sozobon-Release 07.
        - Sollte jetzt auch mit Alias-Programmen unter Gemini zurechtkommen
          (reflink.ttp), da zuerst versucht wird, das Programm mit system()
          zu starten.
        - Bugfix: Ein lokales Array war zu gro fr den Stack. Eigentlich
          htte das Programm abstrzen mssen. Warum es trotzdem lief,
          wei ich auch nicht;-)
        - In den Beipielen der man page stand "reflink" statt "refcheck".
        - Man page jetzt auch als Hypertext REFCHECK.HYP.
        - Modulnamen wurden evtl. nicht in voller Lnge verglichen. Z.B.
          wurde beim Modul "aip" irrtmlich auch "aip_auto" oder "aip_prog"
          erkannt!
        - Neues Konzept: Es wird nicht mehr nach REF-Dateien, sondern nach
          HYP-Dateien und dann erst nach der passenden REF-Datei gesucht!
          Dadurch funktioniert der Schalter -d jetzt auch, wenn man nur mit
          der ALL.REF arbeitet und die Module werden nicht gelscht. Nur,
          wenn die HYP-Datei fehlt, wird ein Modul aus der ALL.REF gelscht!
        - Maximale Anzahl der HYP-Dateien auf 1024 erhht (bisher 200). Ich
          denke, das sollte frs erste ausreichen!
    1.2 - Neue Option -k. Hiermit werden die REF-Dateien nach erfolgreicher
          Aktualisierung/Aufnahme von der Platte gelscht! Besonders
          geeignet fr diejenigen, die nur mit der ALL.REF arbeiten!
        - Optionsbeschreibung im Usage-Text an die man page angepat.
        - Wenn die Environmentvariable HOME existiert, wird die ST-GUIDE.INF
          zuerst dort gesucht.
   1.21 - Starten von REFLINK funktionierte nicht richtig, wenn weder eine
          Shell gefunden wurde, noch die System-Environmentvariable PATH
          existierte oder einen gltigen Pfad fr REFLINK enthielt. Im
          aktuellen Verzeichnis wurde auch nicht gesucht. Jetzt wird, wenn
          keie Shell existiert, zuerst im aktuellen Verzeichnis gesucht und
          erst wenn das fehlschgt, wird REFLINK mit spawnlp() gestartet.
    1.3 - Bei den Suchvorgngen werden jetzt alle gefundenen Module und
          Dateien angezeigt. Beim Scannen der ALL.REF wird jeweils
          Modulname, Offset und -lnge, bei der HYP-Suche HYP-Name und falls
          vorhanden "+REF", Modulname und -lnge ausgegeben!
        - Absturz beseitigt, wenn die ALL.REF ein Modul mit einer Lnge
          >32767 Bytes enthielt.
        - REFCHECK bercksichtigt jetzt die Tatsache, da auch einfache
          REF-Dateien mehr als ein Modul enthalten knnen, z.B. ENG_GER.REF.
        - Wenn die Option -k gesetzt ist, wird die REF-Datei jetzt nicht
          mehr von REFCHECK gelscht, sondern REFLINK mit der Option -m
          (move) gestartet.
        - Speicheranforderungen (malloc) werden jetzt berprft.
        - Fehlerhaftes spawn-Binding ersetzt. Dank an Jerry Geiger @ B,
          der mir die korrigierte spawn3.o als UUE geschickt hat:-)
        - REFLINK-Aufrufe mit der Option -d (lschen) werden jetzt in einem
          einzigen Aufruf zusammengefat, wenn die REFCHECK-Option -i nicht
          gesetzt ist oder bei einer Abfrage durch [a] deaktiviert wurde!
        - Option -s (silent) beschrnkt die Bildschirmausgaben auf das
          ntigste -> schneller.
        - Die Option -g (global) wurde nicht beachtet, wenn eine REF-Datei
          noch nicht in der ALL.REF vorhanden war.
    1.4 - Variablen REFLINK und REFCHECK-OPT in der Datei ST-GUIDE.INF
          werden ausgewertet.
    1.5 - HYP/REF-Dateien und Module in der ALL.REF werden jetzt auch dann
          einander korrekt zugeordnet, wenn der Name der HYP-Datei nicht mit
          dem Modulnamen in der REF-Datei bereinstimmt. Aktuelles Beispiel:
          Dateiname: POV.HYP/REF, Modulname: POV_DEUT (deutsche Version)!
        - Wenn der Dateiname nicht mit dem Modulnamen bereinstimmt,
          erscheint in der Ausgabeliste (wenn Option -s nicht gesetzt) ein
          Ausrufezeichen (!) hinter dem Modulnamen. Auerdem wird eine
          gesetzte move-Option (-k) fr diese REF-Datei deaktiviert, damit
          die Datei erhalten bleibt und REFCHECK beim nchsten Aufruf den
          Modulnamen korrekt zuordnen kann (sonst wrde das Modul evtl.
          gleich wieder aus der ALL.REF gelscht)!
    1.6 - Zum Starten von REFLINK mu jetzt zwingend die Variable
          REFLINK in der ST-GUIDE.INF definiert sein. Der Start ber
          eine System-Shell wird nicht mehr untersttzt!
        - Wenn in der ST-GUIDE.INF die Variable REFPATHS gefunden wird, wird
          diese anstelle von PATHS benutzt. So kann man bestimmen, da nur
          die REF-Dateien von Hypertexten aus bestimmten Pfaden in die
          ALL.REF aufgenommen werden.
        - Die mgliche Anzahl der HYP-Dateien/Module ist nur noch durch
          den freien Speicherplatz beschrnkt.
    1.7 - Bugfix: REFCHECK strzte ab, wenn keine ALL.REF existierte.

COPYRIGHT
    REFCHECK ist Freeware, d.h. das Programm darf beliebig  weitergegeben
    werden, allerdings nur unverndert und komplett mit allen Dateien.

DISCLAIMER
    Ich bernehme keine Haftung fr Schden jeglicher Art, die durch die
    Benutzung oder Nicht-Benutzung von REFCHECK entstanden sind.

AUTOR
    Frank Rger
    Tecklenburger Strae 21
    D-49525 Lengerich

    email: Frank Rger @ OS2 im Mausnetz bzw.
           Frank_Rueger@os2.maus.de aus dem InterNet
