{**************************************
 *    einfaches xFSL-Testprogramm     *
 *  Pascal-Umsetzung von Thomas Much  *
 **************************************
 *   Softdesign Computer Software     *
 *   Thomas Much, Gerwigstrae 46,    *
 * 76131 Karlsruhe, (0721) 62 28 41   *
 *        Thomas Much @ KA2           *
 *     uk48@rz.uni-karlsruhe.de       *
 * much@rpkhp7.mach.uni-karlsruhe.de  *
 * http://www.uni-karlsruhe.de/~uk48/ *
 **************************************
 *  erstellt am:         20.05.1995   *
 *  letztes Update am:   21.06.1995   *
 **************************************}

{ Das ursprngliche C-Testprogramm (fix31) stammt von Dirk Haun.
  Teile des Pascal-Quelltextes stammen aus ObjectGEM bzw. Texel }

{$IFDEF DEBUG}
	{$B+,D+,G-,I-,L+,P-,Q+,R+,S+,T-,V-,X+,Z-}
{$ELSE}
	{$B+,D-,G-,I-,L-,P-,Q-,R-,S-,T-,V-,X+,Z-}
{$ENDIF}

program Call_xFSL;

uses

	Tos,Gem;

label

	_ende,_applexit;

const

	_p_cookies      =   $5a0;

	FF_SYSTEM       =  $0001;
	FF_MONOSPACED   =  $0002;
	FF_PROPORTIONAL =  $0004;
	FF_BITMAP       =  $0008;
	FF_SPD          =  $0010;
	FF_TTF          =  $0020;
	FF_PFB          =  $0040;
	FF_CFN          =  $0080;
	FF_VECTOR       =  FF_SPD or FF_TTF or FF_PFB or FF_CFN;
	FF_ALL          =  FF_MONOSPACED or FF_PROPORTIONAL or FF_VECTOR or FF_BITMAP;
	FF_CHANGED      =  $8000;
  FF_VEKTOR       =  FF_VECTOR;
  FF_MONO         =  FF_MONOSPACED;
  FF_PROP         =  FF_PROPORTIONAL;

	CC_WINDOW       =  $0001;
	CC_APPMODAL     =  $0002;
	CC_FIX31        =  $0004;
	CC_FAKESTYLE    =  $0008;
	CC_CLOSER       =  $0010;
	CC_NOSIZE       =  $0100;
	CC_NOCOLOR      =  $0200;
	CC_NOATTR       =  $0400;
	CC_NOWIDTH      =  $0800;
	CC_NOKERN       =  $1000;
	CC_NOSKEW       =  $2000;
	CC_DFLTSIZE     = $10000;
	CC_INVSTYLE     = $20000;

	XF_SIZE         =  $0001;
	XF_COLOR        =  $0002;
	XF_ATTR         =  $0004;
	XF_WIDTH        =  $0008;
	XF_KERN         =  $0010;
	XF_SKEW         =  $0020;
	XF_FIX31        =  $0100;
	XF_POPUP        =  $0200;
	XF_DRAGDROP     =  $0400;

	xFS_PARERROR    =     -9;
	xFS_LOADERROR   =     -8;
	xFS_RES_ERROR   =     -7;
	xFS_NO_HANDLE   =     -6;
	xFS_NO_WINDOW   =     -5;
	xFS_NO_FONTS    =     -4;
	xFS_NO_FONTSIZE =     -3;
	xFS_ACTIVE      =     -2;
	xFS_ERROR       =     -1;
	xFS_STOP        =      0;
	xFS_OK          =      1;
	xFS_HELP        =      2;
	xFS_EVENT       =      3;
	xFS_POPUP       =      4;

	THA_LEFT        =      0;
	THA_CENTER      =      1;
	THA_RIGHT       =      2;

	TVA_BOTTOM      =      0;
	TVA_CENTER      =      1;
	TVA_TOP         =      2;

	V_CHAR_IND      =     -1;
	V_CHAR_ASC      =     -2;
	V_CHAR_PRT      =     -3;
	V_CHAR_ALL      =     -4;

	MAP_DIRECT      =      0;
	MAP_ASCII       =      1;

type

	PLongint = ^longint;

	PCookieID = ^TCookieID;
	TCookieID = array [0..3] of char;

	PCookie = ^TCookie;
	TCookie = record
		ID:  TCookieID;
		Val: longint
	end;

	UFSLPtr = ^UFSL;
	UFSL    = record
		id           : longint;
		version      : word;
		dialtyp      : integer;
		font_selinit : function(d1,d2: pointer; d3,d4,d5: longint): integer;
		font_selinput: function(d1,d2: pointer; d3,d4,d5: longint; vdihandle,fanz: integer; text: PChar; ftype: integer; var fretid,fretsize: integer): integer;
		helpbutton,
		helpfunc     : longint
	end;

	FSIZE = record
		case boolean of
		false: (size  : integer);
		true:  (size31: fix31)
	end;

	FONTINFOPtr = ^FONTINFO;
	FONTINFO    = record
		fontid,
		fonttype  : integer;
		fontname  : PChar;
		fontsize,
		fontwidth : FSIZE;
		trackkern,
		pairkern  : byte;
		fontattr,
		fontskew,
		fontcol,
		backcol,
		halign,
		valign,
		rotation,
		validtype : integer;
		validchars: PChar
	end;

	xFSL_PARPtr = ^xFSL_PAR;
	xFSL_PAR    = record
		par_size,
		pfi_size   : integer;
		control    : longint;
		headline,
		example,
		helptext   : PChar;
		font       : FONTINFOPtr;
		fontflags  : word;
		poptext    : PChar;
		num_entries,
		sel_entry  : integer;
		popup      : pointer;
		helpinfo   : PChar
	end;

	xFSLPtr = ^xFSL;
	xFSL    = record
		id        : TCookieID;
		revision  : word;
		product   : TCookieID;
		version   : word;
		xfsl_input: function(d1,d2: pointer; d3,d4,d5: longint; vdihandle: integer; fontflags: word; headline: PChar; var fid,fsize: integer): integer;
		xfsl_init : function(d1,d2: pointer; d3,d4,d5: longint; vdihandle: integer; xpar: xFSL_PARPtr): integer;
		xfsl_event: function(d1,d2: pointer; d3,d4,d5: longint; xfsl_handle: integer; event: EVENTPtr): integer;
		xfsl_exit : procedure(d1,d2: pointer; d3,d4,d5: longint; xfsl_handle: integer);
		xfsl_info : function(d1,d2: pointer; d3,d4,d5: longint): longint;
	end;

var

	callufsl : UFSLPtr;
	callxfsl : xFSLPtr;
	fntinf   : FONTINFO;
	gl_apid,
	fid,
	fsiz,
	xhandle,
	vdiHandle,
	dummy,i,
	addFonts,
	ret      : integer;
	titel,
	example  : string;
	xpar     : xFSL_PAR;
	ev       : EVENT;
	fontname : array [0..39] of char;
	workIn   : workin_ARRAY;
	workOut  : workout_ARRAY;


function getjar: longint;

	begin
		getjar:=PLongint(_p_cookies)^
	end;


function clearufsl: longint;

	begin
		callufsl^.dialtyp:=0;
		callufsl^.helpbutton:=0;
		callufsl^.helpfunc:=0;
		clearufsl:=0
	end;


function ltoa(l: longint): string;
	var s: string;

	begin
		str(l,s);
		ltoa:=s
	end;


function GetCookie(cookie: TCookieID; var value: longint): boolean;
  var cookiejar: PCookie;

  begin
  	GetCookie:=false;
    cookiejar:=PCookie(supexec(getjar));
    if cookiejar<>nil then
			while PLongint(cookiejar)^<>0 do
				with cookiejar^ do
					if ID=cookie then
						begin
							value:=Val;
							GetCookie:=true;
							exit
						end
					else
						inc(longint(cookiejar),8)
  end;


procedure Error(e: integer);

	begin
		case e of
			xFS_LOADERROR:
				form_alert(1,'[2][Fehler beim Nachladen|von XFSL.OVL!][Abbruch]');
			xFS_RES_ERROR:
				form_alert(1,'[2][Auflsung zu gering!][Abbruch]');
			xFS_NO_HANDLE:
				form_alert(1,'[2][Kein Handle frei!][Abbruch]');
			xFS_NO_WINDOW:
				form_alert(1,'[2][Kein Fenster frei!][Abbruch]');
			xFS_NO_FONTS:
				form_alert(1,'[2][Keine Fonts geladen!][Abbruch]');
			xFS_NO_FONTSIZE:
				form_alert(1,'[2][Fontgre konnte nicht|identifiziert werden!][Abbruch]');
			xFS_ACTIVE:
				form_alert(1,'[2][Fontselektor ist bereits aktiv!][Abbruch]');
			xFS_ERROR:
				form_alert(1,'[2][Speichermangel!][Abbruch]')
		else
			if e<0 then form_error(-31-e)
		end
	end;


procedure FontChanged(ID,Size,Color,Effects,Skew: integer);

	begin
		form_alert(1,'[0][ID='+ltoa(ID)+', Size='+ltoa(Size)+',|Color='+ltoa(Color)+', Effects='+ltoa(Effects)+',|Skew='+ltoa(Skew)+'][   OK   ]')
	end;


begin
	{ ACHTUNG: Es finden _keine_ AES/VDI-Fehlerberprfungen statt!!! }
	gl_apid:=appl_init;
	vdiHandle:=graf_handle(dummy,dummy,dummy,dummy);
	for i:=0 to 9 do workIn[i]:=1;
	workIn[10]:=2;
	v_opnvwk(workIn,vdiHandle,workOut);
	if vdiHandle<=0 then goto _applexit;
	addFonts:=vst_load_fonts(vdiHandle,0);
	if GetCookie('xFSL',longint(callxfsl)) then
		begin
			if callxfsl=nil then goto _ende;
			titel:='Whlen Sie einen Font aus!'#0;
			with callxfsl^ do
				begin
					if id='xFSL' then
						if revision>=4 then
							begin
								fillchar(xpar,sizeof(xFSL_PAR),0);
								fillchar(fntinf,sizeof(FONTINFO),0);
								xpar.par_size:=sizeof(xFSL_PAR);
								xpar.pfi_size:=sizeof(FONTINFO);
								xpar.control:=CC_WINDOW or CC_FAKESTYLE;
								xpar.headline:=@titel[1];
								xpar.fontflags:=FF_ALL;
								example:='The quick brown fox jumps over the lazy dog.'#0;
								xpar.example:=@example[1];
								fontname[0]:=#0;
								fntinf.fontname:=fontname;
								fntinf.fontcol:=Black;
								xpar.font:=@fntinf;
						    xhandle:=xfsl_init(nil,nil,0,0,0,vdiHandle,@xpar);
						    if xhandle=xFS_NO_WINDOW then
						    	begin
						    		xpar.control:=xpar.control and not(CC_WINDOW);
								    xhandle:=xfsl_init(nil,nil,0,0,0,vdiHandle,@xpar)
						    	end;
						    if xhandle>=0 then
						    	begin
						    		repeat
											ev.ev_mflags:=0;
											ret:=xfsl_event(nil,nil,0,0,0,xhandle,@ev)
										until (ret=xFS_OK) or (ret=xFS_STOP);
										xfsl_exit(nil,nil,0,0,0,xhandle);
										if ret=xFS_OK then
											with xpar.font^ do FontChanged(fontid,fontsize.size,fontcol,fontattr,fontskew)
										else
											Error(ret)
									end
								else
									if xfsl_input(nil,nil,0,0,0,vdiHandle,FF_ALL,@titel[1],fid,fsiz)=1 then FontChanged(fid,fsiz,-1,-1,0)
							end
				end
		end
	else
		if GetCookie('UFSL',longint(callufsl)) then
			begin
				if callufsl=nil then goto _ende;
				supexec(clearufsl);
				with callufsl^ do
					begin
						font_selinit(nil,nil,0,0,0);
						if font_selinput(nil,nil,0,0,0,vdiHandle,workOut[10]+addFonts,nil,0,fid,fsiz)=1 then FontChanged(fid,fsiz,-1,-1,0)
					end
			end
		else
			form_alert(1,'[2][Weder xFSL- noch UFSL-Cookie vorhanden. ][ Abbruch ]');
	_ende:
	vst_unload_fonts(vdiHandle,0);
  v_clsvwk(vdiHandle);
	_applexit:
	appl_exit
end.
